<?php

namespace Drupal\recurly_aegir\Provisioners;

use Drupal\user\Entity\User;
use Drupal\recurly_aegir\Provisioners\RecurlyAegirSiteProvisioner;

/**
 * Class for creating new sites via Aegir's Web service API.
 */
abstract class RecurlyAegirSiteCreateProvisioner extends RecurlyAegirSiteProvisioner {

  /**
   * The list of provisioner classes available for creating new sites.
   *
   * This won't be necessary when we switch to plug-in discovery.
   */
  const PROVISIONERS_CREATE = [
    'RecurlyAegirSiteCloneProvisioner',
    'RecurlyAegirSiteInstallProvisioner',
  ];

  /**
   * {@inheritdoc}
   */
  public function __construct($endpoint, $hostname, User $client, $template = NULL) {
    parent::__construct($endpoint, $hostname, $client, $template);

    // Ensure mandatory parameters are set.
    if (empty($template)) {
      throw new Exception('Site-creation provisioners must be provided with a template ID on construction.');
    }
  }

  /**
   * {@inheritdoc}
   */
  public static function getTaskType() {
    return static::TASK_TYPE;
  }

}
